/*************************************************************/
/** ColorLib - color graphic library for fx-CG20 - fx-CG10  **/
/** ColorLib is a free software                             **/
/**                                                         **/
/** @author Lancelot                                        **/
/** Thanks to Planete Casio helping me in this project      **/
/**                                                         **/
/** @file ColorLib.h                                        **/
/** Include header for ColorLib                             **/
/**                                                         **/
/** @date 10-20-2013                                        **/
/** version 1.93                                            **/
/*************************************************************/

#ifndef COLORLIB
#define COLORLIB


#define LCD_WIDTH_PX 384
#define LCD_HEIGHT_PX 216
//#define VRAM 0xA8000000
//#define VRAM GetVRAMAdress();
#define MONOSPACE    0x00000001
#define ANTIALIASING 0x00000002

#define abs(a) ((a) < 0 ? -(a) : (a))
#define min(a,b) (((a) < (b))? (a) : (b))
#define max(a,b) (((a) > (b))? (a) : (b))
#define sgn(a) ((a) < 0 ? (-1) : (a) > 0 ? (1) : (a))


// text fontions
void CL_text_drawPoint(int x, int y, int size, int color, int alpha);
int CL_text_readPix(char* data, int x, int y, int w, int h);
void CL_text_antialias(int x, int y, int size, int color, int alpha, int corner);
//void CL_text_setFont(Font* font);
//Font* CL_text_getActualFont();
void CL_text_printC(int x, int y, char c, int size, int color);
void CL_text_print(int x, int y, char* c, int size, int color);
int CL_text_widthC(char c);
int CL_text_width(char* c);


//Graphic fonctions
void CL_line(int x1, int y1, int x2, int y2, short color);
void CL_drawCircle(int x0, int y0, int rayon, int couleur);
void CL_point(int x, int y, int color);
void CL_CopySpriteNbitMaskedAlpha(const unsigned char* data, int x, int y, int width, int height, const color_t* palette, color_t maskColor, unsigned int bitwidth,int alpha);
void CL_alphaSprite(int x, int y, int width, int height, short* bitmap, short alpha);
void CL_CopySpriteNbitMasked(const unsigned char* data, int x, int y, int width, int height, const short* palette, short maskColor, unsigned int bitwidth);
void CL_drawPoly(int xy[], int points, int color);
void CL_drawFilledCircle(short x, short y, short rayon, int couleur);
void CL_drawFilledCircleAlpha(short x, short y, short rayon, int couleur, int alpha);
void CL_drawPointAlpha(int x, int y, int size, int color, int alpha);
int CL_Filled_polygon_quicksord_partition(int *t, int p, int r); 
void CL_Filled_polygon_quicksord(int* t, int p, int r);
void CL_Filled_polygon(const int *x, const int *y, int nb_vertices, unsigned short color);
void CL_Horizontal_Line(int x1, int x2, int y, unsigned short color);
void* GetVRAMAdress();
void CL_drawDiscus(int x0, int y0, int rayon, int couleur);
void CL_Vertical_Line(int x, int y1, int y2, unsigned short color);
void CL_Filled_Rectangle( int xi, int yi, int xi2, int yi2, unsigned short color);
short CL_Getpixel(short x, short y);


#endif // COLORLIB

